
#include "Matrix3x3.h"

Matrix3x3::Matrix3x3(){
	for(int n = 0; n < 3; n++)
		for(int m = 0; m < 3; m++)
			fMatrix[n][m] = 0.0f;

	return;
}

Matrix3x3::Matrix3x3(float fMatrix[3][3]){
	for(int n = 0; n < 3; n++)
		for(int m = 0; m < 3; m++)
			this->fMatrix[n][m] = fMatrix[n][m];

	return;
}

Matrix3x3::Matrix3x3(Point3D ptCol1, Point3D ptCol2, Point3D ptCol3){
	fMatrix[0][0] = ptCol1.x;
	fMatrix[1][0] = ptCol1.y;
	fMatrix[2][0] = ptCol1.z;

	fMatrix[0][1] = ptCol2.x;
	fMatrix[1][1] = ptCol2.y;
	fMatrix[2][1] = ptCol2.z;

	fMatrix[0][2] = ptCol3.x;
	fMatrix[1][2] = ptCol3.y;
	fMatrix[2][2] = ptCol3.z;

	return;
}

Matrix3x3::Matrix3x3(float fVal11, float fVal12, float fVal13, float fVal21, float fVal22, float fVal23, float fVal31, float fVal32, float fVal33){
	fMatrix[0][0] = fVal11;
	fMatrix[1][0] = fVal12;
	fMatrix[2][0] = fVal13;

	fMatrix[0][1] = fVal21;
	fMatrix[1][1] = fVal22;
	fMatrix[2][1] = fVal23;

	fMatrix[0][2] = fVal31;
	fMatrix[1][2] = fVal32;
	fMatrix[2][2] = fVal33;

	return;
}

Matrix3x3::~Matrix3x3(void){}

Point3D Matrix3x3::operator *(Point3D ptArg){
	Point3D ptResult;

	ptResult = Point3D(0.0f, 0.0f, 0.0f);
	
	ptResult.x = fMatrix[0][0] * ptArg.x + fMatrix[0][1] * ptArg.y + fMatrix[0][2] * ptArg.z;
	ptResult.y = fMatrix[1][0] * ptArg.x + fMatrix[1][1] * ptArg.y + fMatrix[1][2] * ptArg.z;
	ptResult.z = fMatrix[2][0] * ptArg.x + fMatrix[2][1] * ptArg.y + fMatrix[2][2] * ptArg.z;

	return ptResult;
}
