
#ifndef __POLYGON2D_H_
#define __POLYGON2D_H_


#include <vector>

#include "Point2D.h"


/*!
 * \brief
 * Class to represent a 2D polygon and provide basic alogrithms to deal with them.
 * 
 * The class assumes that the polygon is given as a list of n-1 vertices where 
 * v[n] = v[0].
 */
class Polygon2D
{
public:
	Polygon2D();
	Polygon2D(std::vector<Point2D> vVertices);

	double Area();
	bool isConvex();
	bool Contains(Point2D ptTest);

private:
	std::vector<Point2D> vVertices;
};


#endif
