
#ifndef __GLOBAL_H_
#define __GLOBAL_H_


#include "Point2D.h"
#include "Rect2D.h"

#include <vector>


#define ENSURE_EX(cond, exception) if(!(cond)){throw exception;}
#define ENSURE(cond) ENSURE_EX((cond), "Ensure Exception")


#define SMALL_NUM 0.00000001


enum SIGN{
	SIGN_NEGATIVE = -1,
	SIGN_NEUTRAL = 0,
	SIGN_POSITIVE = 1
};


SIGN sign(double dNumber);


struct SPOINTWITHDIRECTION{
	Point2D ptPoint;
	float fProjection;
};

//Point2D min(Point2D ptComp1, Point2D ptComp2);
//Point2D max(Point2D ptComp1, Point2D ptComp2);

bool SortAbscissaAsc(Point2D ptPoint1, Point2D ptPoint2);
bool SortDirectionAsc(SPOINTWITHDIRECTION ptPoint1, SPOINTWITHDIRECTION ptPoint2);
bool SortDirectionDesc(SPOINTWITHDIRECTION ptPoint1, SPOINTWITHDIRECTION ptPoint2);

int MaximumAbscissa(std::vector<Point2D> * pvPoints, Point2D * pptResult);
bool MaximumAbscissaMultiple(std::vector<Point2D> * pvPoints, std::vector<Point2D> * pvResult);

int MaximumInDirection(std::vector<Point2D> * pvPoints, Point2D ptDireccion, Point2D * pptResult);

bool BoundingBox(std::vector<Point2D> * pvPoints, Rect2D * prctResult);

void SortPointsByAbscissaAscending(std::vector<Point2D> * pvPoints, std::vector<Point2D> * pvResult);
void SortPointsByDirectionAscending(std::vector<Point2D> * pvPoints, Point2D ptDireccion, std::vector<Point2D> * pvResult);

void PointsInRect(std::vector<Point2D> * pvPoints, Rect2D rcFrame, std::vector<Point2D> * pvResult);

void SortPointsAngular(std::vector<Point2D> * pvPoints, Point2D ptRef, std::vector<Point2D> * pvResult);


#endif
